$compile unit

$error all-
$lib all-

defint a-z




$if 0

          Dosname - Function: Test DOS Nameing Conventions
--------------------------------------------------------------------------


Purpose:  Tests a string variable and verifies it meets DOS nameing
          conventions for DOS versions 1.x, 2.x, 3.x.


Syntax:   TestDOSname%( name$ , type% )

          name$ - any valid string variable or string expression.

          type% - Integer defining category of name being tested.

                       where;     0 - File name
                                  1 - Path name
                                  2 - Extention name
                                  3 - Drive specifier


Function: Returns a 0(zero) if string meets criteria.
          Returns a 1(one) if string fails to pass.


Remarks:  This function performs two basic tests.

          First, it verifies the maximum size limit has not been exceeded
          for the specified type of name. Sizes: 8 for files, 63 for paths,
          3 for extentions and 2 for a drive specifiers.

          Second, it verifies that no invalid characters are present
          depending upon the type. No type may have characters with
          ASCII values less than 20 nor have a space, plus ...

                File name excludes   . / \ [ ] : | < > + = ; , " * ?

                Path name excludes   . /   [ ] : | < > + = ; , " * ?

                Extention excludes     / \ [ ] : | < > + = ; , " * ?

                Drive name excludes  . / \ [ ]   | < > + = ; , " * ?


Usage:    This function is totally self contained and does not use any
          other user defined procedures or functions. It uses only locally
          declared variables and does not modify the incomming name$ or
          type%.

Example:           A$="MYFILE"
                   A%=0
                   PRINT TestDOSname%(A$,A%)
                   PRINT TestDOSname%("B:",3)
                   PRINT TestDOSname%(".DAT",2)
                   PRINT TestDOSname%("P1\P2",1)
                   PRINT TestDOSname%("B-1986",0)
                   PRINT TestDOSname%("G=105",0)

                   RUN .....    0
                                0
                                0
                                0
                                0
                                1

          Only the last line fails the tests. All others, dependent
          upon the type specified, are within DOS conventions.

$endif






 Function TestDOSname%(N$,T%)  Public
   LOCAL T$, L%, TL%, C%, T1$
   SELECT CASE T%
      CASE =0
         L%=8
      CASE =1
         L%=63
      CASE =2
         L%=3
      CASE =3
         L%=2
   END SELECT
   SELECT CASE T%
      CASE =0
         T$="*?./\[]:|<>+=;, "+CHR$(34)
      CASE =1
         T$="*?./[]:|<>+=;, "+CHR$(34)
      CASE =2
         T$="*?/\[]:|<>+=;, "+CHR$(34)
      CASE =3
         T$="*?./\[]|<>+=;, "+CHR$(34)
   END SELECT
   testDOSname%=0
   TL%=LEN(N$)
   IF TL%>L% THEN
         testDOSname%=1
      ELSE
         FOR C%=1 TO TL%
            T1$=MID$(N$,C%,1)
            IF T1$<CHR$(20) THEN
               testDOSname%=1
               EXIT FOR
            END IF
            IF INSTR(T$,T1$)>0 THEN
               testDOSname%=1
               EXIT FOR
            END IF
         NEXT
   END IF
END Function
