$compile unit

$error all-
$lib all-

defint a-z



' SCREEN.LIB  Special CLS routines 


'Ŀ
' SUBROUTINE ClearWindow(r1%,c1%,r2%,c2%,attr%)                              
'    Clears a rectangular screen "window" with the upper-left corner at      
'    coordinates R1%,C1% and lower-right corner at R2%,C2% to the video      
'    attribute specified as ATTR%.  If ATTR% is -1, clears to the current    
'    attribute at R1%,C1%.                                                   
'

   SUB ClearWindow(r1%,c1%,r2%,c2%,attr%)  Public
      LOCAL va%
      va%=attr%
      IF attr%=-1 THEN
         va%=SCREEN(r1%,c1%,1)
      END IF
      va%=VAL("&h"+HEX$(va%)+"00")
      REG 1,&h0600
      REG 2,va%
      REG 3,256*(r1%-1)+(c1%-1)
      REG 4,256*(r2%-1)+(c2%-1)
      CALL INTERRUPT &h10
   END SUB


'Ŀ
' SUBROUTINE ClearBOL(attr%)                                                 
'    Clears from the beginning-of-line to column BEFORE current cursor       
'    position.  Clears to video attribute ATTR%.  If ATTR% is -1, clears     
'    to the current attribute at the beginning of the line.                  
'

   SUB ClearBOL(attr%)  Public
      LOCAL r%,c%,va%
      r%=CSRLIN : c%=POS(0)-1
      va%=attr%
      IF attr%=-1 THEN
         va%=SCREEN(r%,1,1)
      END IF
      IF c%>=1 THEN
         CALL ClearWindow(r%,1,r%,c%,va%)
      END IF
   END SUB


'Ŀ
' SUBROUTINE ClearBOS(attr%)                                                 
'    Clears from the beginning-of-screen to column BEFORE current cursor     
'    position.  Clears to video attribute ATTR%.  If ATTR% is -1, clears     
'    to the current attribute at the beginning of the screen.                
'

   SUB ClearBOS(attr%)  Public
      LOCAL r%,c%,va%
      r%=CSRLIN : c%=POS(0)-1
      va%=attr%
      IF attr%=-1 THEN
         va%=SCREEN(1,1,1)
      END IF
      IF c%>=1 THEN
         CALL ClearWindow(r%,1,r%,c%,va%)
      END IF
      IF r%>1 THEN
         CALL ClearWindow(1,1,r%,80,va%)
      END IF
   END SUB


'Ŀ
' SUBROUTINE ClearEOL(attr%)                                                 
'    Clears from the current cursor position to the end of the line.         
'    Clears to video attribute ATTR%.  If ATTR% is -1, clears to the         
'    current attribute at the cursor position.                               
'

   SUB ClearEOL(attr%)  Public
      LOCAL r%,c%,va%
      r%=CSRLIN : c%=POS(0)
      va%=attr%
      IF attr%=-1 THEN
         va%=SCREEN(r%,c%,1)
      END IF
      CALL ClearWindow(r%,c%,r%,80,va%)
   END SUB


'Ŀ
' SUBROUTINE ClearEOS(attr%)                                                 
'    Clears from the current cursor position to the end of the screen.       
'    Clears to video attribute ATTR%.  If ATTR% is -1, clears to the         
'    current attribute at the cursor position.                               
'

   SUB ClearEOS(attr%)  Public
      LOCAL r1%,r2%,c1%,c2%,va%
      r%=CSRLIN : c%=POS(0)
      va%=attr%
      IF attr%=-1 THEN
         va%=SCREEN(r1%+1,c1%+1,1)
      END IF
      CALL ClearWindow(r%,c%,r%,80,va%)
      IF r%<25 THEN
         CALL ClearWindow(r%+1,1,25,80,va%)
      END IF
   END SUB