$compile unit

$error all-
$lib all-

defint a-z



' UTILITY.LIB  Other Utility Routines 

'Ŀ
' FUNCTION Soundex$(word$)                                                   
'    Creates "sound-index" string of digits from word/last name/etc.         
'    Can be used for sound-alike name matching, typo/spell check, etc.       
'    Max. length of returned string is the number of consonants in WORD$.    
'

   Function Soundex$(word$)  Public
      LOCAL i%,lt%,sndx$,c$,lastc$,temp$
      lt%=LEN(word$)
      Soundex$="" : IF lt%=0 THEN EXIT Function
      lastc$=""
      sndx$=""
      temp$=UCASE$(word$)
      FOR i%=1 TO lt%
         c$=MID$(temp$,i%,1)
         IF INSTR(lastc$,c$) THEN
            lastc$=lastc$
         ELSEIF INSTR("AEHIOUWY",c$) THEN
            lastc$="AEHIOUWY"
         ELSEIF INSTR("BFPV",c$) THEN
            sndx$=sndx$+"1" : lastc$="BFPV"
         ELSEIF INSTR("CGJKQSXZ",c$) THEN
            sndx$=sndx$+"2" : lastc$="CGJKQSXZ"
         ELSEIF INSTR("DT",c$) THEN
            sndx$=sndx$+"3" : lastc$="DT"
         ELSEIF c$="L" THEN
            sndx$=sndx$+"4" : lastc$="L"
         ELSEIF INSTR("MN",c$) THEN
            sndx$=sndx$+"5" : lastc$="MN"
         ELSEIF c$="R" THEN
            sndx$=sndx$+"6" : lastc$="R"
         END IF
      NEXT
      Soundex$=sndx$
   END Function


'Ŀ
' FUNCTION Extracts$(lookup$,delim$,index%)                                   
'    Simple table lookup function.  Returns the INDEX% numbered item from    
'    the list LOOKUP$, whose items are delimited by DELIM$.  If there are    
'    not at least INDEX% items in the list a null string is returned.        
'

   Function Extracts$(lookup$,delim$,index%)  Public
      LOCAL i%,j%,count%,lt%,temp$
      Extracts$=""
      IF index%<1 THEN EXIT Function
      IF lookup$="" THEN EXIT Function
      IF LEN(delim$)<>1 THEN EXIT Function
      j%=0
      count%=0
      temp$=lookup$+delim$
      lt%=LEN(temp$)
      DO
         i%=j%+1
         j%=INSTR(i%,temp$,delim$)
         INCR count%
      LOOP UNTIL count%=index% OR j%=lt%
      IF count%=index% THEN Extracts$=MID$(lookup$,i%,j%-i%)
   END Function